"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));

var _vue = require("vue");

var _unified = require("unified");

var _rehypePrism = _interopRequireDefault(require("@mapbox/rehype-prism"));

var _remarkGfm = _interopRequireDefault(require("remark-gfm"));

var _rehypeRaw = _interopRequireDefault(require("rehype-raw"));

var _rehypeSlug = _interopRequireDefault(require("rehype-slug"));

var _rehypeRewrite = _interopRequireDefault(require("rehype-rewrite"));

var _rehypeAutolinkHeadings = _interopRequireDefault(require("rehype-autolink-headings"));

var _rehypeStringify = _interopRequireDefault(require("rehype-stringify"));

var _remarkParse = _interopRequireDefault(require("remark-parse"));

var _remarkRehype = _interopRequireDefault(require("remark-rehype"));

var _octiconLink = require("./octiconLink");

var _jsxRuntime = require("react/jsx-runtime");

// @ts-ignore
var _default = (0, _vue.defineComponent)({
  name: 'MarkdownPreview',
  props: {
    rehypePlugins: {
      type: Object,
      "default": []
    },
    remarkPlugins: {
      type: Object,
      "default": []
    },
    source: {
      "default": '',
      type: String
    }
  },
  setup: function setup(props) {
    var remarkPlugins = props.remarkPlugins,
        rehypePlugins = props.rehypePlugins;

    function createHTML(str) {
      return (0, _unified.unified)().use(_remarkParse["default"]).use(_remarkGfm["default"]).use(remarkPlugins || []).use(_remarkRehype["default"], {
        allowDangerousHtml: true
      }).use(_rehypeRaw["default"]).use(_rehypeSlug["default"]).use(_rehypeAutolinkHeadings["default"]).use(_rehypePrism["default"], {
        ignoreMissing: true,
        alias: {
          markup: ['vue', 'html']
        }
      }).use(_rehypeRewrite["default"], {
        rewrite: function rewrite(node) {
          if (node.type == 'element' && /h(1|2|3|4|5|6)/.test(node.tagName) && node.children && Array.isArray(node.children) && node.children.length > 0) {
            var child = node.children[0];

            if (child && child.type === 'element' && child.properties) {
              child.properties = (0, _objectSpread2["default"])({
                className: 'anchor'
              }, child.properties);
              child.children = [(0, _octiconLink.octiconLink)()];
            }
          }
        }
      }).use(rehypePlugins || []).use(_rehypeStringify["default"]).processSync(str).toString();
    }

    return function () {
      return /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
        "class": "markdown-body",
        innerHTML: createHTML(props.source || '')
      });
    };
  }
});

exports["default"] = _default;
module.exports = exports.default;
//# sourceMappingURL=index.js.map